# Program to fit the beta-geometric model to fecundability data,
# and then to fit, k times, data obtained from the bootstrap,
# and produce histograms of -the maximum log-likelihood values,
# and of the parameter estimates.
#_____________________________________________________________________
# k is the number of simulations
# data(i) is the number that wait i cycles; data(13)
# is the number that wait > 12 cycles.
# Calls the function BEGEO, which produces the
# beta-geometric negative log-likelihood.
# Calls the function MULTSIM, which simulates a
# multinomial distribution, and FMINSEARCH.
# 'data' are global, and are set in the driving program
#______________________________________________________________________
	data <- c(29, 16, 17, 4, 3, 9, 4, 5, 1, 1, 1, 3, 7)	
	# the same data are used in
# 'begeo'
# the 'smokers' data
	k <- 100
	n <- sum(data)	# now we set up the multinomial
	p <- data/n	# and simulate from it.
	x1 <- rep(0, k)
	x2 <- rep(0, k)
	x3 <- rep(0, k)
	for(i in 1:k) {
		data <- multsim(n, p)	# simulates new data set;
		y <- nlmin(begeo, c(0.5, 0.05))	# starts from [.5,.05]
		x1[i] <- y$x[1]
		x2[i] <- y$x[2]
		x3[i] <- begeo(y$x)	# in order, this stores, mu, 
	}
# theta, and - the log-
# likelihood at its maximum
	X11()
	hist(x1, xlab = "mu")	# we now plot the three
	X11()
	hist(x2, xlab = "theta")	# histograms
	X11()
	hist(x3, xlab = "-log-likelihood")
