# Program to produce the isometric projection
# of the Cauchy log-likelihood surface
#_________________________________________________________
	data <- c(1.09, -0.23, 0.79, 2.31, -0.81)
	n <- length(data)
	ncols <- length(seq(-1, 2.5, 0.05))
	nrows <- length(seq(0.01, 2.2, 0.05))
	a <- matrix(seq(-1, 2.5, 0.05), nrow = nrows, ncol = ncols, byrow = T)
	b <- matrix(seq(0.01, 2.2, 0.05), nrow = nrows, ncol = ncols, byrow = F)
	loglik <- n * log(b)
	k <- matrix(1, nrow = nrow(a), ncol = ncol(a))
	for(i in 1:n) {
		loglik <- loglik - log(b^2 + (data[i] * k - a)^2)
	}
	wireframe(loglik ~ a * b, scales = list(arrows = F))
