cvsearch <-
function(alpha)
{
#
# CVSEARCH calculates the cross-validation criterion, CV(alpha)
#   used in fitting a cubic spline, and which is then minimised.
#   global matrices are, Q, R, specified by the cubic-spline program.
#   The 'y-values', Y, produced by the data generation program are global.
#   Code due to Paul Terrill.
#
	A <- solve(diag(length(Y)) + alpha * Q %*% solve(R) %*% t(Q))
	gamma <- solve(R + alpha * t(Q) %*% Q, t(Q) %*% Y)
	g <- Y - alpha * Q %*% matrix(gamma, ncol = 1)
	x <- ((Y - g)/(1 - diag(A)))^2
	sum(x)/length(Y)
}
