# Program to simulate multinomial data corresponding to
# a simple bird survival model, for 4 years of recovery.
# There are three probabilites : the annual survival probabilities,
#'phi_1' and 'phi_2', and the reporting probability, 'lam'
# 'n' denotes the number of birds in the cohort.
# the 'data' vector is global, as it may be used by the function ECOLIK,
# which forms the corresponding negative log-likelihood, to be minimised
# by fminsearch, for example.
# Calls MULTSIM
#___________________________________________________________________________
	n <- 1000
	phi1 <- 0.2
	phi2 <- 0.5
	lam <- 0.6	# sets the model probabilities
	p <- rep(0, 4)
	p[1] <- lam * (1 - phi1)
	sav <- (1 - phi2)
	p[2] <- lam * phi1 * sav
	p[3] <- p[2] * phi2
	p[4] <- p[3] * phi2	# the vector 'p' contains the
# cell probabilities, apart from
# the 'left-over' cell.
	data <- multsim(n, p)	# can cope with probabilites
# which do not sum to unity
