gammasim <- 
function(r, n)
{
#
# GAMMASIM simulates n independent realisations of a gamma(r,1) random
#   variable, using rejection.
#
	y <- rep(0, n)
	for(j in 1:n) {
		t <- 2	# inefficient SPLUS programming
		u <- 3	# values to start the 'while' command
		while(t < u) {
			e <-  - r * log(runif(1))
			t <- ((e/r)^(r - 1)) * exp((1 - r) * (e/r - 1))
			u <- runif(1)
		}
		y[j] <- e
	}
	y
}
