# Program to perform Gibbs sampling for Example 7.1, and fixed n.
# 'm': denotes the number of cycles before sampling
# 'k': denotes the number of repeats to be used
# 'n','alpha' and 'beta' are the known parameters of the
# bivariate distribution.
# Calls the functions BETASIM and BINSIM.
#_______________________________________________________________________
	m <- 50
	k <- 100
	n <- 20
	alpha <- 1
	beta <- 2
	y1 <- rep(0, k)
	x1 <- rep(0, k)
	for(j in 1:k) {
		x <- n * runif(1)	# start for x
		for(i in 2:m) {
			y <- betasim(alpha + x, n - x + beta, 1)
			x <- binsim(n, y, 1)
		}
		y1[j] <- y	# we record the values
		x1[j] <- x	# after m cycles
	}
	X11()
	hist(y1, xlab = "y")
	X11()
	hist(x1, xlab = "x")
