grad <-
function(funfcn, x)
{
#
# GRAD Calculates a central difference approximation to the first-order
#   differential of 'funfcn' with respect to 'x'.
#   The difference width used is twice 'delta'.
#   Code due to Ted Catchpole.
#
	delta <- 10^(-6)
	t <- length(x)
	g <- rep(0, t)
	Dx <- delta*diag(t)	# eye :identity matrix
	for(i in 1:t) {
		g[i] <- (do.call("funfcn", list(x + Dx[i,  ])) - do.call(
			"funfcn", list(x - Dx[i,  ])))/(2 * delta)
	}
# feval : Ref : HL, p155.
	g
}
