hessian <-
function(funfcn, x)
{
#
# HESSIAN Calculates a central difference approximation to the
#   hessian matrix of 'funfcn', with respect to 'x'
#   The width of the difference used is twice 'delta'.
#   Code due to Ted Catchpole.
#
	delta <- 10^(-6)
	t <- length(x)
	h <- matrix(0, t, t)
	Dx <- delta * diag(t)	# eye :identity matrix
	for(i in 1:t) {
		for(j in 1:t) {
			h[i, j] <- (do.call("funfcn", list(x + Dx[i,  ] + Dx[j, 
				])) - do.call("funfcn", list(x + Dx[i,  ] - Dx[
				j,  ])) - do.call("funfcn", list(x - Dx[i,  ] + 
				Dx[j,  ])) + do.call("funfcn", list(x - Dx[i,  
				] - Dx[j,  ])))/(4 * delta^2)
		}
	}
	h
}
