kernel <- 
function(y, data, k1)
{
#
# KERNEL Calculates a kernel density estimate for a sample in 'data'.
#   'y' is the value at which we want the kernel estimate.
#   'k1' can be chosen to vary the amount of smoothing;
#   Calls the function DELTA.
#
	n <- length(data)
	h <- (k1 * sqrt(var(data)))/n^0.2	
	# 'h' is the window-width. A particular
# dependence on std() and n is used here
	z <- 0
	for(i in 1:n) {
		z <- z + delta((y - data[i])/h)	
	# delta is the function which specifies
# the form of kernel to be used
	}
	z/(n * h)
}
