logit <-
function(t)
{
#
#LOGIT Calculates the negative log-likelihood for a logistic
#  model and quantal response data
#  x is the 'dose'
#  n is the number of individuals at each 'dose'
#  r is the number of individuals that respond at each 'dose'
#  x,n and r are global variables, set in the driving program
#
	w <- rep(1, length(x))
	alpha <- t[1]
	beta <- t[2]
	y <- w/(1 + exp(alpha + beta * log(x)))
	z <- w - y
	loglik <- r %*% (log(y)) + (n - r) %*% (log(z))
 - loglik[1, 1]
}
