longscore <-
function(x)
{
#
# LONGSCORE illustrates how score tests can be done using numerical
#   approximations to the derivatives that we need.
#   In this particular application, 'x' contains the maximum-
#   likelihood estimates of the beta-geometric parameters, mu and theta.
#   Calls GRAD and HESSIAN.
#
        H <- hessian(preference, x)
        print(H)
        g <- grad(preference, x)
        print(g)
        J <- solve(H)
        print(J)
        s <- matrix(g[1:2], nrow = 1) %*% (J[1:2, 1:2]) %*% matrix(g[1:2], ncol
                 = 1)
        cat(s, "\n")
}
