# Program to illustrate Monte-Carlo inference.
# We have a random sample from	a normal distribution with unit variance
# and we plot the log-likelihood as a function of the mean, without using
# the form of the pdf.
#__________________________________________________________________________
# n is the sample size taken
# s is the sample size for the simulations at each theta
# k1 determines the kernel smoothing.
# Calls the function KERNEL.
#_____________________________________________________________________________
	n <- 50
	s <- 200
	k1 <- 1
	y <- rnorm(n)
	y <- y + rep(1, n)	# y is the basic N(1,1) sample;
	y2 <- y^2
	y3 <- sum(y2)
	                	# we plot the log-likelihood, which is
                                # known in this example, over the
                                # range, 0-2, for comparison
	theta <- seq(0.1, 2, 0.01)
	s2 <- rep(1, length(theta))
	knownlogl <- (( - n * log(2 * pi))/2) * s2 - s2 * (y3/2) + sum(y) * 
		theta - (n/2) * (theta^2)
	plot(theta, knownlogl, type = "l", xlab = "", ylab = "")	
	                        # now we move on to the kernel stage
	set <- seq(0.1, 2, 0.05)
	tt <- mclogl <- rep(0, length(set))
	k <- 0
	for(thet in set) {
		k <- k + 1
		tt[k] <- thet
		             	# now for each value of theta we simulate
                                # a sample of size s. This goes into x.
		x <- rnorm(s)
		x <- x + thet
		mclogl[k] <- 0
		for(i in 1:n) {
			mclogl[k] <- mclogl[k] + log(kernel(y[i], x, k1))
		}
	}
	points(tt, mclogl)
	                  	# finally we form and plot the moving
                                # average
	movav <- mclogl[2:(k - 1)] + mclogl[1:(k - 2)] + mclogl[3:k]
	lines(tt[2:(k - 1)], movav/3, lty = 8)
