multsim <-
function(N,theta)
{
#
# MULTSIM simulates a multinomial distribution
#   'N' is the index of the distribution.
#   'theta' is the vector containing the cell probabilities.
#   Code due to Ted Catchpole.
#
 if (sum(theta)<1) {                 # the procedure can cope with
    theta <- c(theta,1-sum(theta))   # the cell probabilites summing to
 }                                   # less than unity
 n <- length(theta)
 cump <- cumsum(theta)               # 'cump' holds the crucial cumulative
 m <- runif(N)                       # sums of probabilities
 cumx <- rep(0,n)
 for (j in 1:n) {
     cumx[j] <- sum(m<cump[j])       # uses the relational operator, '<' :
 }                                   # creates a vector of 0/1s : entry = 1
 c(cumx[1],diff(cumx))               # iff corresponding entry of m < cump(j)
}                                    # ref: HL, p82.
