nr1 <-
function(funfcn, x)
{
#
# NR1 performs the Newton Raphson line search for steepest ascent, 
#   starting at vector, 'x'.
#
	g <- 1	# this is an arbitrary starting value
	while(abs(g) > 1e-05) {
# for the 'while' command
		g <- grad(funfcn, x)
		h <- hessian(funfcn, x)
		x <- x - solve(t(h), g)	# this corresponds to Equation(3.1)
	}
	x
}
