# Program to perform the Newton-Raphson iteration of Equation (3.3), 
# using the gradient and Hessian numerical approximations of Figure 3.3
# 'data' are global, so that they can be accessed by the 'cauchy'
# function.
# Calls the functions GRAD, HESSIAN and CAUCHY.
#_______________________________________________________________________
	data <- c(-4.2, -2.85, -2.3, -1.02, 0.7, 0.98, 2.72, 3.5)
	x0 <- c(0.7, 0.5)	# starting value for Newton Raphson
	g <- c(1, 1)	# value selected to start the 'while' loop
	while(vecnorm(g) > 1e-05) {
		g <- grad(cauchy, x0)
		h <- hessian(cauchy, x0)
		xn <- matrix(x0, 2, 1) - solve(h) %*% matrix(g, 2, 1)
		x0 <- xn
	}
	cat("x0:", x0, "\n")	# the maximum-likelihood estimate
	cat("g:", g, "\n")	# the gradient at the maximum
	cat("eig(h):", eigen(h, only.values = T), "\n")	
	# the eigen values of the Hessian at
# maximum-likelihood estimate
