# Program to fit the beta-geometric model to fecundability data,
# and then to fit, k times, data simulated from the fitted model,
# and produce histograms of -the maximum log-likelihood values,
# and of the parameter estimates.
#________________________________________________________________
# k is the number of simulations
# data(i) is the number that wait i cycles; data(13)
# is the number that wait > 12 cycles
# Calls the function BEGEO, which produces the
# beta-geometric negative log-likelihood.
# Calls the function MULTSIM, which simulates a
# multinomial distribution, and FMINSEARCH.
# 'data' are global, and set in the driving program.
#_________________________________________________________________
	data <- c(29, 16, 17, 4, 3, 9, 4, 5, 1, 1, 1, 3, 7)	
	# the same data are used in
# 'begeo'
# the 'smokers' data
	k <- 100
	n <- sum(data)
	x0 <- c(0.5, 0.05)	# start for the
	x <- nlmin(begeo, x0)	# maximum-likelihood estimation
	y <- begeo(x$x)	# 'x' contains the mle
	cat(y, "\n")
	cat(x$x, "\n")	# 'y' is the -log-lik at the mle
	p <- rep(0, length(data))	# now we set up the multinomial
# and simulate from it.
	p[1] <- x$x[1]	# this is mu
	s <- p[1]
	for(i in 2:12) {
# iterative specification of
		p[i] <- p[i - 1] * (1 - sum(x$x)/(1 + (i - 1) * x$x[2]))	
	# probabilities
		s <- s + p[i]
	}
	p[13] <- 1 - s	# probability of right-censoring
	x1 <- rep(1, k)
	x2 <- rep(1, k)
	for(i in 1:k) {
		data <- multsim(n, p)	# simulates new data set;
		y <- nlmin(begeo, x0)	# starts from x0
		x1[i] <- y$x[1]
		x2[i] <- y$x[2]
		x3[i] <- begeo(y$x)	# in order, this stores, mu, 
	}
# theta, and - the log-
# likelihood at its maximum
	X11()
	hist(x1, xlab = "mu")	# we now plot the three
	X11()
	hist(x2, xlab = "theta")	# histograms
	X11()
	hist(x3, xlab = "-log-likelihood")
