# Program to fit a two-component Poisson mixture
# using the EM algorithm. We display just 'nit' iterations.
# Calls the function DIVIDE.
# global variables are 'data' and 'k'.
#___________________________________________________________________________
	nit <- 50
	data <- c(162, 267, 271, 185, 111, 61, 27, 8, 3, 1)
	s <- sum(data)
	k <- length(data)
	ind <- 0:(k - 1)
	pie <- 0.359	# first guess at pi, the probability
	theta1 <- 1.2   # of the first population, and
	theta2 <- 3.7	# theta1 and theta2
	data1 <- divide(theta1, theta2, pie)
	data2 <- data - data1
	cat("\nit   pi  theta1 theta2\n")
	for(j in 1:nit) {
# the maximisation stage
		s1 <- sum(data1)
		s2 <- (s - s1)
		pie <- s1/s
		theta1 <- sum(ind * data1)/s1
		theta2 <- sum(ind * data2)/s2
		x <- c(j, pie, theta1, theta2)
		data1 <- divide(theta1, theta2, pie)
		data2 <- data - data1
		cat(x[1], format(round(x[2:4], digits = 4)), "\n")	
	# the expectation stage
	}
