zeropo <- 
function(lambda)
{
#
# ZEROPO calculates the negative log-likelihood corresponding
#   to a zero-truncated Poisson distribution, of parameter 'lambda'.
#   'data' are a global row vector, and declared in the driving program.
#
	n <- length(data)	# n is the largest value in the
# sample
	p <- rep(0, n + 1)
	p[1] <- exp( - lambda)	# this is pr(0)
	for(i in 2:(n + 1)) {
		p[i] <- (p[i - 1] * lambda)/(i - 1)	
	# iterative formation of the
# Poisson probabilities;
	}
	p <- p/(1 - p[1])	# these are the truncated Poisson
# probabilities.
	y <-  - c(0, data) %*% log(p)
	y[1, 1]
}
