# Program to take a data set
# from a zero-truncated Poisson distribution, 
# and then  estimate the Poisson parameter using the
# EM algorithm. For illustration, we show the result of
# 'nit' iterations.
#________________________________________________________________
	nit <- 10
	data <- rep(0, 14)
	data[2:14] <- c(7, 9, 13, 16, 19, 24, 27, 33, 18, 14, 9, 4, 2)
	data[1] <- 1	# this is the first E-step
	z <- seq(0, 13, 1)
	for(i in 1:nit) {
		w <- sum(data)
		n <- z %*% data
		mean <- n/w	# this is the maximisation stage
		e1 <- exp( - mean)
		data[1] <- e1 * w	# this is the next E-stage
		cat("mean =", mean, "\n")
	}
