zipsim <-
function(lambda, w, n)
{
#
#ZIPSIM simulates n realisations of a zero-inflated Poisson random
#  variable, of parameter lambda, and probability 'w' of additional
#  zeros.
#  Calls BINSIM, POISSIM
#
	k <- binsim(n, w, 1)	# k is the number of extra zeros
	y1 <- rep(0, k)
	y2 <- poissim(lambda, n - k)
	c(y1, y2)
}
